*       ķ
*                                                                
*        07/19/93             dcompare.prg                       
*                       FoxPro Version 2.x Source Code           
*       Ķ
*                                                                
*        Bill Nicholson  70400,3672                              
*                                                                
*        Nicholson Computer Consulting                           
*        996 Glendale Drive                                      
*        Batavia, OH 45103   (513) 752-0540                      
*                                                                
*        Description:  Compare the structure of two dBase        
*                      format databases. Print the results       
*                      on the screen. This is useful when        
*                      undocumented changes have been made to an 
*                      application and those changes must be     
*                      detected. This program detects the        
*                      following changes:                        
*                                                                
*                      1. Fields added to either database        
*                      2. Fields that have been modified         
*                          (character changed to numeric, etc.)  
*       Ķ
*         Useage: Call this program as a subroutine:             
*                 DO COMPARE WITH "file1", "file2"               
*                                                                
*                file1 and file2 are xBase format database files.
*                The results of the comparison are printed on    
*                screen.                                         
*                                                                
*       Ķ
*         History:                                               
*          7/19/93  Initial Release                              
*                                                                
*       Ľ

PROCEDURE compare
PARAMETERS pf1, pf2

CLOSE DATABASES
SET TALK OFF
SET ECHO OFF
SET SCOREBOARD OFF
? "--------------------------------------------------------"
? "Comparing " + pf1 + " and " + pf2
? "--------------------------------------------------------"

SELECT 0
USE &pf1
f1unique = SYS(3)
COPY STRUCTURE EXTENDED TO &f1unique
USE

SELECT 0
USE &pf2
f2unique = SYS(3)
COPY STRUCTURE EXTENDED TO &f2unique
USE

*? "file 1 = " + f1unique
*? "file 2 = " + f2unique

SELECT 0
USE &f1unique ALIAS f1
SELECT 0
USE &f2unique ALIAS f2

*======================================================
SELECT f1
GO TOP
*list
diff = .F.
? "--------------------------------------------------------"
? "Searching for fields that are missing from " + pf2
DO WHILE !EOF()
	SELECT f2
	GO TOP
	LOCATE FOR f1->field_name = f2->field_name
	IF !FOUND()
		diff = .T.
		? f1->field_name
	ENDIF
	SELECT f1
	SKIP
ENDDO
IF !diff
	? "No missing fields were detected."
ENDIF
*==================================================
SELECT f2
GO TOP
*list
diff = .F.
? "--------------------------------------------------------"
? "Searching for fields that have been added to " + pf2
DO WHILE !EOF()
	SELECT f1
	GO TOP
	LOCATE FOR f2->field_name = f1->field_name
	IF !FOUND()
		diff = .T.
		? f2->field_name
	ENDIF
	SELECT f2
	SKIP
ENDDO
IF !diff
	? "No new fields were found."
ENDIF

*======================================================
SELECT f1
GO TOP
*list
diff = .F.
? "--------------------------------------------------------"
? "Searching for fields that have been changed in " + pf2
DO WHILE !EOF()
	SELECT f2
	GO TOP
	LOCATE FOR f1->field_name = f2->field_name
	ldiff = .F.
	IF FOUND()
		IF f1->field_type <> f2->field_type
			diff = .T.
			? IIF (!ldiff, f1->field_name + "...", "")
			ldiff = .T.
			?" Field Type changed from " + f1->field_type + " to "  + f2->field_type
		ENDIF
		IF f1->field_len <> f2->field_len
			diff = .T.
			? IIF (!ldiff, f1->field_name + "...", "")
			ldiff = .T.
			?" Field Length changed from " + ALLTRIM(STR(f1->field_len)) + " to "  + ALLTRIM(STR(f2->field_len))
		ENDIF

		IF f1->field_dec <> f2->field_dec
			diff = .T.
			? IIF (!ldiff, f1->field_name + "...", "")
			ldiff = .T.
			?" Field Decimal Width changed from " + ALLTRIM(STR(f1->field_dec)) + " to "  + ALLTRIM(STR(f2->field_dec))
		ENDIF

	ENDIF
	SELECT f1
	SKIP
ENDDO
IF !diff
	? "No changed fields were detected."
ENDIF

WAIT

SELECT f1
USE
DELETE FILE f1unique + ".dbf"

SELECT f2
USE
DELETE FILE f2unique + ".dbf"

